/* =================================================================== */
/** ======== DÉBUT CODE FOURNI ======= */
/** ========= NE PAS MODIFIER ======== */

#include <stdlib.h>
#include <stdio.h>
#include <stdbool.h>
#include <assert.h>
#include <string.h>
#include <stdint.h>

/* ------------------------------------------------------------------- */
/** génère un tableau de nombres pseudo-aléatoires de longueur `length` */
uint32_t* rands(uint32_t u0, uint32_t len){
  uint64_t a = 1400306129;
  uint64_t n = 2038075531;

  uint32_t* res = malloc(len * sizeof(uint32_t));

  res[0] = u0;
  
  for (int i = 1; i < len; i++){
    res[i] = ( a * (uint64_t)res[i-1]) % n;
  }

  return res;
}

/* ------------------------------------------------------------------- */
/** fonction de hachage à utiliser dans une table de hachage de taille `N` */
uint32_t hash(uint32_t x, uint32_t N){
  x = ((x >> 16) ^ x) * 0x45d9f3b;
  x = ((x >> 16) ^ x) * 0x45d9f3b;
  x = (x >> 16) ^ x;
  return ((uint32_t) x) % N;
}

/** ========= FIN CODE FOURNI ======== */
/* =================================================================== */
/** == DÉBUT DE VOTRE CODE PARTIE 2 == */
